searchNodes=[{"doc":"Elixir library used to enable SAML SP SSO to a Phoenix/Plug based application.","ref":"Samly.html","title":"Samly","type":"module"},{"doc":"Returns authenticated user SAML Assertion. The struct includes the attributes sent from IdP as well as any corresponding locally computed/derived attributes. Returns nil if the current Plug session is not authenticated. Parameters conn - Plug connection Examples # When there is an authenticated SAML assertion % Assertion { } = Samly . get_active_assertion ( )","ref":"Samly.html#get_active_assertion/1","title":"Samly.get_active_assertion/1","type":"function"},{"doc":"Returns value of the specified attribute name in the given SAML Assertion. Checks for the attribute in computed map first and attributes map next. Returns a UTF-8 binary or a list of UTF-8 binaries (in case of multi-valued) if the given attribute is present. Returns nil if attribute is not present. Parameters assertion - SAML assertion obtained by calling get_active_assertion/1 name : Attribute name Examples assertion = Samly . get_active_assertion ( ) # returns a list if the attribute is multi-valued roles = Samly . get_attribute ( assertion , &quot;roles&quot; ) computed_fullname = Samly . get_attribute ( assertion , &quot;fullname&quot; )","ref":"Samly.html#get_attribute/2","title":"Samly.get_attribute/2","type":"function"},{"doc":"SAML assertion returned from IDP upon successful user authentication. The assertion attributes returned by the IdP are available in attributes field as a map. Any computed attributes (using a Plug Pipeline by way of configuration) are available in computed field as map. The attributes can be accessed directly from attributes or computed maps. The Samly.get_attribute/2 function can be used as well. This function will first look at the computed attributes. If the request attribute is not present there, it will check in attributes next.","ref":"Samly.Assertion.html","title":"Samly.Assertion","type":"module"},{"doc":"","ref":"Samly.Assertion.html#t:attr_name_t/0","title":"Samly.Assertion.attr_name_t/0","type":"type"},{"doc":"","ref":"Samly.Assertion.html#t:attr_value_t/0","title":"Samly.Assertion.attr_value_t/0","type":"type"},{"doc":"","ref":"Samly.Assertion.html#t:t/0","title":"Samly.Assertion.t/0","type":"type"},{"doc":"SAML 2.0 Service Provider This should be added to the hosting Phoenix/Plug application's supervision tree. This GenServer initializes the SP configuration and loads the IDP medata XML containing information on how to communicate with the IDP. # application.ex children = [ # ... worker ( Samly.Provider , [ ] ) , ] Check README.md Configuration section.","ref":"Samly.Provider.html","title":"Samly.Provider","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Samly.Provider.html#child_spec/1","title":"Samly.Provider.child_spec/1","type":"function"},{"doc":"Refresh the provider configuration, allowing runtime-configuration to be applied after application start.","ref":"Samly.Provider.html#refresh_providers/0","title":"Samly.Provider.refresh_providers/0","type":"function"},{"doc":"Stores SAML assertion in ETS. This provider creates an ETS table (during initialization) to keep the authenticated SAML assertions from IdP. The ETS table name in the configuration is optional. Options :table - ETS table name (optional) Value must be an atom Do not rely on how the state is stored in the ETS table. Configuration Example config :samly , Samly.State , opts : [ table : :my_ets_table ] This can be used as an example when creating custom stores based on redis, memcached, database etc.","ref":"Samly.State.ETS.html","title":"Samly.State.ETS","type":"module"},{"doc":"Stores SAML assertion in Plug session. This provider uses Plug session to save the authenticated SAML assertions from IdP. The session key name in the configuration is optional. Options :key - Session key name used when saving the assertion (optional) Value is either a binary or an atom Configuration Example config :samly , Samly.State , store : Samly.State.Session , opts : [ key : :my_assertion ]","ref":"Samly.State.Session.html","title":"Samly.State.Session","type":"module"},{"doc":"Specification for Samly state stores.","ref":"Samly.State.Store.html","title":"Samly.State.Store","type":"behaviour"},{"doc":"Removes the given SAML assertion from the store. May raise an error if there is a failure. An authenticated session must be terminated after calling this.","ref":"Samly.State.Store.html#c:delete_assertion/3","title":"Samly.State.Store.delete_assertion/3","type":"callback"},{"doc":"Returns a Samly assertion if present in the store. Returns nil if the assertion for the given key is not present in the store.","ref":"Samly.State.Store.html#c:get_assertion/3","title":"Samly.State.Store.get_assertion/3","type":"callback"},{"doc":"Initializes the store. The options returned from this function will be given to get_assertion/3 , put_assertion/4 and delete_assertion/3 .","ref":"Samly.State.Store.html#c:init/1","title":"Samly.State.Store.init/1","type":"callback"},{"doc":"Saves the given SAML assertion in the store. May raise an error if there is a failure. An authenticated session should not be established in that case.","ref":"Samly.State.Store.html#c:put_assertion/4","title":"Samly.State.Store.put_assertion/4","type":"callback"},{"doc":"The name_id should not be used independent of the idp_id . It is within the scope of idp_id . Together these form the assertion key.","ref":"Samly.State.Store.html#t:assertion_key/0","title":"Samly.State.Store.assertion_key/0","type":"type"},{"doc":"IdP identifier associated with the assertion.","ref":"Samly.State.Store.html#t:idp_id/0","title":"Samly.State.Store.idp_id/0","type":"type"},{"doc":"SAML nameid returned by IdP.","ref":"Samly.State.Store.html#t:name_id/0","title":"Samly.State.Store.name_id/0","type":"type"},{"doc":"Options passed during the store initialization.","ref":"Samly.State.Store.html#t:opts/0","title":"Samly.State.Store.opts/0","type":"type"},{"doc":"The subject in a SAML 2.0 Assertion. This is part of the Samly.Assertion struct. The name field in this struct should not be used in any UI directly. It might be a temporary randomly generated ID from IdP. Samly internally uses this to deal with IdP initiated logout requests. If an authentication request was sent from Samly (SP initiated), the SAML response is expected to include the original request ID. This ID is made available in Samly.Subject.in_response_to . If the authentication request originated from the IDP (IDP initiated), there won't be a Samly request ID associated with it. The Samly.Subject.in_response_to will be an empty string in that case.","ref":"Samly.Subject.html","title":"Samly.Subject","type":"module"},{"doc":"","ref":"Samly.Subject.html#t:t/0","title":"Samly.Subject.t/0","type":"type"},{"doc":"A SAML 2.0 Service Provider Single-Sign-On Authentication library. This Plug library can be used to SAML enable a Plug/Phoenix application. This has been used in the wild with the following Identity Providers: Okta Ping Identity OneLogin ADFS Nexus GO Shibboleth SimpleSAMLphp Google This library uses Erlang esaml to provide plug enabled routes.","ref":"readme.html","title":"Samly","type":"extras"},{"doc":"# mix.exs # v1.0.0 uses esaml v4.2 which in turn relies on cowboy 2.x # If you need to work with cowboy 1.x, you need the following override: # {:esaml, &quot;~&gt; 3.7&quot;, override: true} defp deps ( ) do [ # ... { :samly , &quot;~&gt; 1.0&quot; } , ] end","ref":"readme.html#setup","title":"Samly - Setup","type":"extras"},{"doc":"Add Samly.Provider to your application supervision tree. # application.ex children = [ # ... { Samly.Provider , [ ] } ]","ref":"readme.html#supervision-tree","title":"Samly - Supervision Tree","type":"extras"},{"doc":"Make the following change in your application router. # router.ex # Add the following scope ahead of other routes # Keep this as a top-level scope and **do not** add # any plugs or pipelines explicitly to this scope. scope &quot;/sso&quot; do forward &quot;/&quot; , Samly.Router end","ref":"readme.html#router-change","title":"Samly - Router Change","type":"extras"},{"doc":"Samly needs a private key and a corresponding certificate. These are used to sign the SAML requests when communicating with the Identity Provider. This certificate should be made available to Samly via config settings. It should also be made available to the Identity Provider so it can verify the SAML signed requests. You can create a self-signed certificate for this purpose. You can use phx.gen.cert mix task that is available as part of Phoenix 1.4 or use openssl directly to generate the key and corresponding certificate. (Check out samly_howto README.md for this.)","ref":"readme.html#certificate-and-key-for-samly","title":"Samly - Certificate and Key for Samly","type":"extras"},{"doc":"Samly expects information about the Identity Provider including information about its SAML endpoints in an XML file. Most Identity Providers have some way of exporting the IdP metadata in XML form. Some may provide a web UI to export/save the XML locally. Others may provide a URL that can be used to fetch the metadata. For example, SimpleSAMLPhp IdP provides a URL for the metadata. You can fetch it using wget . wget -- no - check - certificate - O idp1_metadata . xml https :// idp1 . samly : 9091 / simplesaml / saml2 / idp / metadata . php If you are using the SimpleSAMLPhp administrative Web UI, login with you admin credentials ( https://idp1.samly:9091/simplesaml ). Go to the Federation tab. At the top there will be a section titled &quot;SAML 2.0 IdP Metadata&quot;. Click on the Show metadata link. Copy the metadata XML from this page and save it in a local file ( idp1_metadata.xml for example). Make sure to save this XML file and provide the path to the saved file in Samly configuration.","ref":"readme.html#identity-provider-metadata","title":"Samly - Identity Provider Metadata","type":"extras"},{"doc":"Samly has the ability to support multiple Identity Providers. All IdPs that Samly needs to talk to must have an identifier (idp_id). This IdP id will be used in the service provider URLs. This is how Samly figures out which SAML request corresponds to what IdP so that it can perform relevant validation checks and process the requests/responses. There are two options when it comes to how the idp_id is represented in the Service Provider SAML URLs. URL Path Segment In this model, the idp_id is present as a URL path segment. Here is an example URL: https://do-good.org/sso/auth/signin/affiliates . The idp_id in this URL is &quot;affiliates&quot;. If you have more than one IdP, only this last part changes. The URLs for this model are: Description URL Sign-in button/link in Web UI /sso/auth/signin/affiliates Sign-out button/link in Web UI /sso/auth/signout/affiliates SP Metadata URL https://do-good.org/sso/sp/metadata/affiliates SAML Assertion Consumer Service https://do-good.org/sso/sp/consume/affiliates SAML SingleLogout Service https://do-good.org/sso/sp/logout/affiliates The path segment model is the default one in Samly . If there is only one Identity Provider, use this mode. These URL routes are automatically created based on the configuration information and the above mentioned router scope definition. Use the Sign-in and Sign-out URLs shown above in your application's Web UI buttons/links. When the end-user clicks on these buttons/links, the HTTP GET request is handled by Samly which internally does a POST that in turn sends the appropriate SAML request to the IdP. Subdomain in Host Name In this model, the subdomain name is used as the idp_id. Here is an example URL: https://ngo.do-good.org/sso/auth/signin . Here ngo is the idp_id. The URLs supported by Samly in this model look different. Description URL Sign-in button/link in Web UI /sso/auth/signin Sign-out button/link in Web UI /sso/auth/signout SP Metadata URL https://ngo.do-good.org/sso/sp/metadata SAML Assertion Consumer Service https://ngo.do-good.org/sso/sp/consume SAML SingleLogout Service https://ngo.do-good.org/sso/sp/logout Take a look at samly_howto - a reference/demo application on how to use this library. Make sure to use HTTPS URLs in production deployments. Target URL for Sign-In and Sign-Out Actions The sign-in and sign-out URLs (HTTP GET) mentioned above optionally take a target_url query parameter. Samly will redirect the browser to these URLs upon successfully completing the sign-in/sign-out operations initiated from your application. This target_url query parameter value must be x-www-form-urlencoded .","ref":"readme.html#identity-provider-id-in-samly","title":"Samly - Identity Provider ID in Samly","type":"extras"},{"doc":"# config/dev.exs config :samly , Samly.Provider , idp_id_from : :path_segment , service_providers : [ %{ id : &quot;do-good-affiliates-sp&quot; , entity_id : &quot;urn:do-good.org:affiliates-app&quot; , certfile : &quot;path/to/samly/certfile.pem&quot; , keyfile : &quot;path/to/samly/keyfile.pem&quot; , #contact_name: &quot;Affiliates Admin&quot;, #contact_email: &quot;affiliates-admin@do-good.org&quot;, #org_name: &quot;Do Good&quot;, #org_displayname: &quot;Goodly, No evil!&quot;, #org_url: &quot;https://do-good.org&quot; } ] , identity_providers : [ %{ id : &quot;affiliates&quot; , sp_id : &quot;do-good-affiliates-sp&quot; , base_url : &quot;https://do-good.org/sso&quot; , metadata_file : &quot;idp1_metadata.xml&quot; , #pre_session_create_pipeline: MySamlyPipeline, #use_redirect_for_req: false, #sign_requests: true, #sign_metadata: true, #signed_assertion_in_resp: true, #signed_envelopes_in_resp: true, #allow_idp_initiated_flow: false, #allowed_target_urls: [&quot;https://do-good.org&quot;], #nameid_format: :transient } ] Parameters Description idp_id_from (optional) :path_segment or :subdomain . Default is :path_segment . Service Provider Parameters id (mandatory) identity_id (optional) If omitted, the metadata URL will be used certfile (optional) This is needed when SAML requests/responses from Samly need to be signed. Make sure to set this in a production deployment . Could be omitted during development if your IDP is setup to not require signing. If that is the case, the following Identity Provider Parameters must be explicitly set to false: sign_requests , sign_metadata keyfile (optional) Similar to certfile contact_name (optional) Technical contact name for the Service Provider contact_email (optional) Technical contact email address org_name (optional) SAML Service Provider (your app) Organization name org_displayname (optional) SAML SP Organization displayname org_url (optional) Service Provider Organization web site URL Identity Provider Parameters id (mandatory) This will be the idp_id in the URLs sp_id (mandatory) The service provider definition to be used with this Identity Provider definition base_url (optional) If missing Samly will use the current URL to derive this. It is better to define this in production deployment. metadata_file (mandatory if metadata is not set) Path to the IdP metadata XML file obtained from the Identity Provider. This will be ignored if metadata is non-nil. metadata (mandatory if metadata_file is not set)) String containing IdP metadata XML obtained from the Identity Provider. pre_session_create_pipeline (optional) Check the customization section. use_redirect_for_req (optional) Default is false . When this is false , Samly will POST to the IdP SAML endpoints. sign_requests , sign_metadata (optional) Default is true . signed_assertion_in_resp , signed_envelopes_in_resp (optional) Default is true . When true , Samly expects the requests and responses from IdP to be signed. allow_idp_initiated_flow (optional) Default is false . IDP initiated SSO is allowed only when this is set to true . allowed_target_urls (optional) Default is [] . Samly uses this only when allow_idp_initiated_flow parameter is set to true . Make sure to set this to one or more exact URLs you want to allow (whitelist). The URL to redirect the user after completing the SSO flow is sent from IDP in auth response as relay_state . This relay_state target URL is matched against this URL list. Set the value to nil if you do not want this whitelist capability. nameid_format (optional) When specified, Samly includes the value as the NameIDPolicy element's Format attribute in the login request. Value must either be a string or one of the following atoms: :email , :x509 , :windows , :krb , :persistent , :transient . Use the string value when you need to specify a non-standard/custom nameid format supported by your IdP. Authenticated SAML Assertion State Store Samly internally maintains the authenticated SAML assertions (from LoginResponse SAML requests). There are two built-in state store options available - one based on ETS and the other on Plug Sessions. The ETS store can be setup using the following configuration: config :samly , Samly.State , store : Samly.State.ETS , opts : [ table : :my_ets_table ] This state configuration is optional. If omitted, Samly uses Samly.State.ETS provider by default. Options Description opts (optional) The :table option is the ETS table name for storing the assertions. This ETS table is created during the store provider initialization if it is not already present. Default is samly_assertions_table . Use Samly.State.Session provider in a clustered deployment. This provider uses the Plug Sessions to keep the authenticated SAML assertions. This session based provider can be enabled using the following: config :samly , Samly.State , store : Samly.State.Session , opts : [ key : :my_assertion_key ] Options Description opts (optional) The :key is the name of the session key where assertion is stored. Default is :samly_assertion .","ref":"readme.html#samly-configuration","title":"Samly - Samly Configuration","type":"extras"},{"doc":"Once authentication is completed successfully, IdP sends a &quot;consume&quot; SAML request to Samly . Samly in-turn performs its own checks (including checking the integrity of the &quot;consume&quot; request). At this point, the SAML assertion with the authenticated user subject and attributes is available. The subject in the SAML assertion is tracked by Samly so that subsequent logout/signout request, either service provider initiated or IdP initiated would result in proper removal of the corresponding SAML assertion. Use the Samly.get_active_assertion function to get the SAML assertion for the currently authenticated user. This function will return nil if the user is not authenticated. Avoid using the subject in the SAML assertion in UI. Depending on how the IdP is setup, this might be a randomly generated id. You should only rely on the user attributes in the assertion. As an application working with an IdP, you should know which attributes will be made available to your application and out of those attributes which one should be treated as the logged in userid/name. For example it could be &quot;uid&quot; or &quot;email&quot; depending on how the authentication source is setup in the IdP.","ref":"readme.html#saml-assertion","title":"Samly - SAML Assertion","type":"extras"},{"doc":"Pipeline Samly allows you to specify a Plug Pipeline if you need more control over the authenticated user's attributes and/or do a Just-in-time user creation. The Plug Pipeline is invoked after the user has successfully authenticated with the IdP but before a session is created. This is just a vanilla Plug Pipeline. The SAML assertion from the IdP is made available in the Plug connection as a &quot;private&quot;. (The pipeline plugs have access to the idp_id in this assertion.) If you want to derive new attributes, create an Elixir map data ( %{} ) and update the computed field of the SAML assertion and put it back in the Plug connection private with Conn.put_private call. Here is a sample pipeline that shows this: defmodule MySamlyPipeline do use Plug.Builder alias Samly . { Assertion } plug :compute_attributes plug :jit_provision_user def compute_attributes ( conn , _opts ) do assertion = conn . private [ :samly_assertion ] # This assertion has the idp_id # %Assertion{idp_id: idp_id} = assertion first_name = Map . get ( assertion . attributes , &quot;first_name&quot; ) last_name = Map . get ( assertion . attributes , &quot;last_name&quot; ) computed = %{ &quot;full_name&quot; =&gt; &quot; \#{ first_name } \#{ last_name } &quot; } assertion = % Assertion { assertion | computed : computed } conn |&gt; put_private ( :samly_assertion , assertion ) # If you have an error condition: # conn # |&gt; send_resp(404, &quot;attribute mapping failed&quot;) # |&gt; halt() end def jit_provision_user ( conn , _opts ) do # your user creation here ... conn end end Make this pipeline available in your config: config :samly , Samly.Provider , identity_providers : [ %{ # ... pre_session_create_pipeline : MySamlyPipeline , # ... } ] State Store Take a look at the implementation of Samly.State.ETS or Samly.State.Session and use those as examples showing how to create your own state store (based on redis, memcached, database etc.).","ref":"readme.html#customization","title":"Samly - Customization","type":"extras"},{"doc":"Samly initiated sign-in/sign-out requests send RelayState to IdP and expect to get that back. Mismatched or missing RelayState in IdP responses to SP initiated requests will fail (with HTTP 403 access_denied ). Besides the RelayState , the request and response idp_id s must match. Response is rejected if they don't. Samly makes the original request ID that an auth response corresponds to in Samly.Subject.in_response_to field. It is the responsibility of the consuming application to use this information along with the validity period in the assertion to check for replay attacks . The consuming application should use the pre_session_create_pipeline to perform this check. You may need a database or a distributed cache such as memcache in a clustered setup to keep track of these request IDs for their validity period to perform this check. Be aware that in_response_to field is not set when IDP initialized authorization flow is used. OOTB SAML requests and responses are signed. Signature digest method supported: SHA256 . Some Identity Providers may be using SHA1 by default. Make sure to configure the IdP to use SHA256 . Samly will reject ( access_denied ) IdP responses using SHA1 . esaml provides additional checks such as trusted certificate verification, recipient verification among others. By default, Samly signs the SAML requests it sends to the Identity Provider. It also expects the SAML reqsponses to be signed (both assertion and envelopes). If your IdP is not configured to sign, you will have to explicitly turn them off in the configuration. It is highly recommended to turn signing on in production deployments. Encrypted Assertions are supported in Samly . There are no explicit config settings for this. Decryption happens automatically when encrypted assertions are detected in the SAML response. Supported Encryption algorithms Make sure to use HTTPS URLs in production deployments.","ref":"readme.html#security-related","title":"Samly - Security Related","type":"extras"},{"doc":"How to setup a SAML 2.0 IdP for development purposes? Docker based setup of SimpleSAMLPhp is made available at samly_simplesaml Git Repo. Check out the README.md file of this repo. There is also a Docker based setup of Shibboleth . Checkout the corresponding README.md file in samly_shibboleth Git Repo. Any sample Phoenix application that shows how to use Samly? Clone the samly_howto Git Repo. Detailed instructions on how to setup and run this application are available in the README.md file in this repo. It is recommended that you use the SamlyHowto application to sort out any configuration issues by making that demo application work successfully with your Identity Provider (IdP) before attempting your application. This demo application supports experimentation with multiple IdPs. How to register the service provider with IdP If you are using samly_simplesaml or samly_shibboleth , the instructions you followed there would take care of registering your Phoenix SAML Service provider appliccation. For any other IdP, follow the instructions from the respective IdP vendor. Common Errors access_denied {:error, :bad_recipient} - Check the base_url in your Samly config setting under indentity_providers . access_denied {:error, :bad_audience} - Make sure that the entity_id in the Samly config setting is correct. access_denied {:envelope, {:error, :cert_no_accepted}} - Make sure the Identity Provider metadata XML file you are using in the Samly config setting is correct and corresponds to the IdP you are attempting to talk to. You get this error if the certificate used by the IdP to sign the SAML responses has changed and you don't have the updated IdP metadata XML file on the Samly end.","ref":"readme.html#faq","title":"Samly - FAQ","type":"extras"}]